/*
Author:
Sreekumar Thaithara Balan 

Name:
data.h

Version:
0.7

Last modified:
30-03-2008

Purpose:
1. Handle input data

Implements:


Todo:
1. This code is very primitive. Need better error handling
2. Data handling equivalant to R

References:


License:
GNU General Public License
This file is part of Exofit.

Exofit is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3, or (at your option)
any later version.

Exofit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Exofit; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
Boston, MA 02110-1301, USA.

*/


#ifndef DATA_H
#define DATA_H

#include<string>
#include<vector>


class Data{

 public:

  class Bad_data{};/*********** IN THE NEXT VERSION ***************/

  //constructors
  Data();
  Data(int,bool);
  Data(char*,int);// Data without a header-> when bool head=false  
  Data(char*,int,bool);// bool head=false is same as above
 
  //functions for examining state of the Data 
  std::string get_data_file() const;

  int get_n_columns() const;
  int get_n_entries() const;
  int get_n_heads() const;

  std::string get_head(int i) const;
  double get_data_entry(int i_row,int j_col) const;
 
  void print_head() const;
  void print_entries() const;

  //functions for modifying the state of the Data 
  void set_data_file(char* file); 
  void set_n_columns(int n);
  void set_data_entry(int i_row,int j_col,double val);

  void read_file();

 private:

  char* data_file;
  int n_column;
  bool hd;

  std::vector<std::string> Head;
  std::vector<double> Entr;
  std::vector<std::vector<double> > Dat;
};
  

/******************* INLINES FOR DATA CLASS **************************/

inline Data::Data()
{
  n_column=1;
  hd=false;
}
inline Data::Data(int col, bool head)
{
  n_column=col;
  hd=head;
}
inline Data::Data(char* filename,int col) 
{
  data_file=filename;
  n_column=col;
  hd=false;// assumes a data without header b default 
}
inline Data::Data(char* filename,int col,bool head)
{
  data_file=filename;
  n_column=col;
  hd=head;
}
inline std::string Data::get_data_file() const
{
  return data_file;
}
inline int Data::get_n_columns() const
{
  return n_column;
}
inline int Data::get_n_entries() const
{
  return Dat.size();
}
inline int Data::get_n_heads() const
{
  return Head.size();
}
inline std::string Data::get_head(int i) const
{
  return Head[i];
}

inline double Data::get_data_entry(int i_row,int j_col) const
{
  return Dat[i_row][j_col];
} 
inline void Data::set_data_file(char* file)
{
  data_file=file;
}
inline void Data::set_n_columns(int n)
{
  n_column=n;
}
inline void Data::set_data_entry(int i_row,int j_col,double val)
{
  Dat[i_row][j_col]=val;
}
#endif //DATA_H
