/*
Author:
Sreekumar Thaithara Balan 

Name:
main.cc

Version:
0.7

Last modified:
30-03-2008

Purpose:
1. Defines the user interface
2. Chek for state data

Implements:
1. main()

Todo:

References:

License:
GNU General Public License
This file is part of Exofit.

Exofit is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3, or (at your option)
any later version.

Exofit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Exofit; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
Boston, MA 02110-1301, USA.

*/


#include<iostream>
#include<fstream>
#include"mcmc.h"


int main(int argc,char *argv[])
{

  // parameters to be taken from
  std::string state_file="state.dat";
  std::ifstream infile_data(argv[1],std::ios::in);
  std::ifstream infile_state(state_file.c_str(),std::ios::in);

  Mcmc mymc;

  if(argc !=2)
    {
      std::cout<<"Usage: "<<argv[0]<<"<data_file>\n";
    }
  else
    {
      std::cout<<"**********************************************************\n";
      std::cout<<"                   Exofit version 0.7\n";
      std::cout<<"**********************************************************\n";

      if(!infile_data.is_open())
	{
	  std::cout<<"Unable to open the data file: "<<argv[1]<<"\n";
	}
      else
	{
	  mymc.set_input_data_file(argv[1]);
	}

      if(infile_state.is_open())
	{
	  std::cout<<"\nFound \"state.dat\" :Taking parameters from state file\n\n";
	  mymc.set_take_state_data(true);
	}


      mymc.run();
    }

  return 0;
}
