/*
Author:
Sreekumar Thaithara Balan 

Name:
control_system.cc

Version:
0.7

Last modified:
30-03-2008

Purpose:
1. To make plot file for a given set of orbital parameters

Implements:


Todo:


References:
1. Suto

License:
GNU General Public License


This file is part of Exofit.

Exofit is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3, or (at your option)
any later version.

Exofit is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Exofit; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
Boston, MA 02110-1301, USA.
*/



#include<iostream>
#include<fstream>
#include"radial_v.h"
#include"data.h"
#include<iomanip>
#include<iostream>
#include<cstdlib>

using namespace std;

int main(void)
{
  char orb_data_file[]="orb_vals.dat";
  
  std::ofstream plot_file;
  plot_file.open("orb_plot.dat",std::ios::trunc); // clear data from outfile
  plot_file.close();

  plot_file.open("orb_plot.dat",std::ios::app);// open in append mode
 
  Data orb_data(orb_data_file,1);
  orb_data.read_file();
 
  const int n_ent=orb_data.get_n_entries();

  double para[7];
  double min;
  double max;

  if(n_ent!=9)
    {
      cout<<"ERROR:The data format is not recognized!\n";
      exit(1);
    }
  else
    {

      para[7];
      for(int i=0;i<7;++i)
	{
	  para[i]=orb_data.get_data_entry(i,0);
	}
      min=orb_data.get_data_entry(7,0);
      max=orb_data.get_data_entry(8,0);
 
      const int n_sample=400;

      for(int i=0;i<n_sample;++i)
	{
	  double time=(0+i*(max-min)/(n_sample-1));
	  plot_file<<setprecision(10)<<min+time<<"\t";
	  plot_file<<setprecision(4)<<Suto::radial_velocity(time,para)<<"\n";
	}
      plot_file.close();
  
      return 0;
    }
}

